/*
  NOME:
  CONGNOME:
  MATRICOLA:
  CODICE CALCOLATORE:
*/

#include <iostream>
#include <cstdlib>
#include <cstring>
#include <fstream>

using namespace std;

/* PUNTO 1 */

/* definizione del tipo DatiVolume */

/* definizione del tipo ListaVolumi */
/* Nota: il campo che punta al nodo successivo si dovra' chiamare next */

/* definizione del tipo ListaNumeriInventario */
/* Nota: il campo che punta al nodo successivo si dovra' chiamare next */


/* PUNTO 2 */
/* dichiarazione funzione ListaVolumiLength */

/* definizione funzione ListaVolumiLength */


/* PUNTO 3 */
/* dichiarazione funzione InArchivio */

/* definizione funzione InArchivio */


/* PUNTO 4 */
/* dichiarazione funzione AggiornaArchivio */

/* definizione funzione AggiornaArchivio */

/* Legge archivio da file */
ListaVolumi * LeggiArchivio(void) {
  ListaVolumi * res = NULL;

  ifstream in;

  in.open("archivio.dat");

  while ( !in.eof()) {
    DatiVolume p;
    
    in.getline(p.autore, 30);
    if (in.fail()) break;
    in.getline(p.titolo, 50);
    if (in.fail()) break;
    in.scan("%d\n%d\n%d\n", &p.prezzo, &p.num, &p.prestito);
    if (in.fail()) break;
    
    res = new ListaVolumi(p, res);
  }
  in.close();
  return res;
}

/* Rilascia memoria dell'archivio */
void RilasciaArchivio(ListaVolumi * l) {
  while(l != NULL) {
    ListaVolumi * n = l;
    l = l->next;
    delete n;
  }
}

/* stampa archivio */
void StampaArchivio(ListaVolumi * l) {
  while(l != NULL) {
    DatiVolume p = l->vol;

    cout << "------------------------------" << endl;
    cout << p.autore << endl;
    cout << p.titolo << endl;
    cout << p.prezzo << endl;
    cout << p.num << endl;
    cout << p.prestito << endl;
    cout << "------------------------------" << endl;
    l = l->next;
  }
}

/* stampa archivio prestiti */
void StampaPrestiti(ListaNumeriInventario * n[50]) {
  for(int i = 0; i < 50; i++) {
    ListaNumeriInventario * l = n[i];

    cout << "Libri in prestito utente[" << i+1 << "] = ";

    while(l != NULL) {
      cout << " " << l->num;
      l = l->next;
    }
    cout << endl;
  }
}

/* Rilascia memoria dell'archivio prestiti */
void RilasciaPrestiti(ListaNumeriInventario n[50]) {
  for(int i = 0; i < 50; i++) {
    ListaNumeriInventario * p = n[i];

    n[i] = NULL;
    while(p != NULL) {
      ListaNumeriInventario * l = p;
      p = p->next;
      delete l;
    }
  }
}

/* La funzione principale main */
int main() {
  /* memorizzazione della dimensione dell'archivio */
  int length;

  /* dichiarazione della variabile archivio per memorizzare
     l'archivio */
  ListaVolumi * archivio;

  ListaNumeriInventario * prestiti[50];

  archivio = LeggiArchivio();
  
  length = ListaVolumiLength(archivio);

  // cout << "Archivio prima" << endl;
  // StampaArchivio(archivio);

  /* inizializziamo l'archivio dei prestiti per ogni utente alla lista
     vuota, corrispondente al fatto che nessun utente ha libri in
     prestito */
  for(int i = 0; i < 50; i++) prestiti[i] = NULL;

  /* Generazione di richieste casuali */
  for(int i = 0; i < 10000; i++) {
    /* generazione di un numero di volume casuale */
    int num = random() % (length+1) + 1;
    /* generazione di un codice di utente casuale */
    int utente = random() % 50 + 1;

    AggiornaArchivio(archivio, prestiti, num, utente);
  }

  // cout << "Archivio dopo" << endl;
  // StampaArchivio(archivio);

  cout << "Stato Prestiti" << endl;
  StampaPrestiti(prestiti);

  /* rialscio memoria archivio */
  RilasciaArchivio(archivio);
  /* rilascio memoria prestiti */
  RilasciaPrestiti(prestiti);
}
