/*
  NOME:
  CONGNOME:
  MATRICOLA:
  DOCUMENTO:
  CODICE CALCOLATORE:
*/

#include <iostream>
#include <cmath>

using namespace std;

// **************************************************
// Prima domanda
// **************************************************
struct StructPunto {
  // inserire qui corpo della struttura
  int x, y;
} TipoPunto;

struct TipoSegmento {
  // inserire qui corpo della struttura
  StructPunto primo, secondo;
};

struct TipoLista {
  // inserire qui corpo della struttura
  TipoSegmento segmento;
  TipoLista * next;
  TipoLista(TipoSegmento seg, TipoLista * n) {
    segmento = seg;
    next = n;
  }
};

// **************************************************

TipoLista * ReadFile(void) {
  TipoLista * result = NULL;
  TipoSegmento s;
  char c;
  c = cin.get();
  while ( (c != EOF) && !cin.eof() ) {
    cin.unget();
    cin >> s.primo.x;
    cin >> s.primo.y;
    cin >> s.secondo.x;
    cin >> s.secondo.y;
    cin >> c;
    result = new TipoLista(s, result);
  }
  return result;
}

void PrintList(TipoLista * l) {
  while (l != NULL) {
    cout << l->segmento.primo.x << " ";
    cout << l->segmento.primo.y << " ";
    cout << l->segmento.secondo.x << " ";
    cout << l->segmento.secondo.y << endl;
    l = l->next;
  }
}

void PrintMaggiore(TipoSegmento s, double l) {
  cout << "Segmento piu' lungo: ";
  cout << s.primo.x << " ";
  cout << s.primo.y << " ";
  cout << s.secondo.x << " ";
  cout << s.secondo.y << endl;
  cout << "Lunghezza = " << l << endl;
}

// **************************************************
// seconda domanda
// **************************************************
bool Parallelo(TipoSegmento s) {
  return ((s.primo.x == s.secondo.x) ||
	  (s.primo.y == s.secondo.y));
}
TipoLista * TogliParalleli(TipoLista * l) {
  // inserire qui il corpo della procedura
  TipoLista * result = NULL;

  while(l != NULL) {
    if (! Parallelo(l->segmento)) {
      result = new TipoLista(l->segmento, result);
    }
    l = l->next;
  }
  return result;
}
// **************************************************


// **************************************************
// terza domanda
// **************************************************
double SegLenght(TipoSegmento s) {
  double result = 0.0;
  double diffx = s.primo.x - s.secondo.x;
  double diffy = s.primo.y - s.secondo.y;

  result = sqrt(diffx*diffx + diffy*diffy);
  return result;
}

void LunghezzaMaggiore(TipoLista * l, TipoSegmento &s, double & ln) {
  // inserire qui il corpo della procedura
  TipoSegmento maxs;
  double lenght;

  if (l != NULL) {
    maxs = l->segmento;
    lenght = SegLenght(maxs);

    l = l->next;
    while(l != NULL) {
      if (SegLenght(l->segmento) > lenght) {
	maxs = l->segmento;
	lenght = SegLenght(l->segmento);
      }
      l = l->next;
    }

    s = maxs;
    ln = lenght;
  }
}
// **************************************************

// **************************************************
// quarta domanda
// **************************************************
void CancellaLista(TipoLista * & l) {
  // inserire qui corpo della funzione
  while (l != NULL) {
    TipoLista * p = l;

    l = l->next;
    delete p;
  }

}


int main(int argc, char *argv[])
{
  TipoLista * lista = NULL;
  TipoLista * lista1 = NULL;
  TipoSegmento s;
  double lenght;

  lista = ReadFile();
  PrintList(lista);

  // Domanda 2:
  // scommentare le quattro righe di codice seguente
  lista1 = TogliParalleli(lista);
  cout << "Lista segmenti non paralleli:" << endl;
  PrintList(lista1);

  // Domanda 4
  CancellaLista(lista);

  // Domanda 3: 
  // Scommentare le tre righe di codice seguente
  LunghezzaMaggiore(lista1, s, lenght);
  PrintMaggiore(s, lenght);

  // Domanda 4
  CancellaLista(lista1);
}



